<template>
  <app-form title="Create List" :open="open" @close="cancelCreate">
    <form-group labelFor="form-create-list-name" label="List Name">
      <form-input
        id="form-create-list-name"
        v-model="name"
        placeholder="Please Provide the name of the list..."
      ></form-input>
    </form-group>
    <template v-slot:footer>
      <button @click="createList" type="button" class="btn btn-primary">
        Create
      </button>
      <button @click="cancelCreate" type="button" class="btn btn-light">
        Cancel
      </button>
    </template>
  </app-form>
</template>

<script lang="ts">
import { defineComponent, PropType } from "vue";
import { v4 as uuidV4 } from "uuid";
import AppForm from "../components/Form.vue";
import FormGroup from "../components/FormGroup.vue";
import FormInput from "../components/FormInput.vue";
import { Board, List } from "@/core/database";

export default defineComponent({
  components: { AppForm, FormGroup, FormInput },
  emits: ["create", "cancel"],
  props: {
    open: {
      type: Boolean,
      required: true,
    },
    board: {
      type: Object as PropType<Board>,
      required: true,
    },
  },
  data() {
    return {
      name: "",
    };
  },
  methods: {
    createList() {
      const newList = new List(uuidV4(), this.name, this.board.id);
      this.$emit("create", newList);
      this.cancelCreate();
    },
    cancelCreate() {
      this.$emit("cancel");
    },
  },
});
</script>
